clear

% %=============================================
% %The following reproduce the results of camera listed in the Table 4.1.
% img=double(imread('camera.png'));
% ker=fspecial('average',9);
% blur=@(f,k)imfilter(f,k,'circular');
% sigma=3;
% og=blur(img,ker);
% g=og+sigma*randn(size(img));
% ForC='F'; %FFT-based preconditioner
% mu=100;
% delta=1;
% frame=1;
% Level=4;
% theta=0.005;wLevel=1/sqrt(2);   %Higher SNRs, more oscilations, and slower.
% %theta=0.01;wLevel=-1;  %Lower SNRs, less oscilations, and faster.
% %parameters for bilateral filtering
% SigmaS=4;
% SigmaR=16;
% %=============================================

% %=============================================
% %The following reproduce the results of Barbara listed in the Table 4.1.
% img=double(imread('barbara.jpg'));
% ker=fspecial('Gaussian',21,1);
% blur=@(f,k)imfilter(f,k,'circular');
% sigma=5;
% og=blur(img,ker);
% g=og+sigma*randn(size(img));
% ForC='F'; %FFT-based preconditioner
% mu=100;
% delta=1;
% frame=1;
% Level=4;
% theta=0.01;
% wLevel=1/2;
% %parameters for bilateral filtering
% SigmaS=32;
% SigmaR=8;
% %=============================================

%=============================================
%The following reproduce the results of Shape listed in the Table 4.1.
img=double(imread('shape150.jpg'));
ker=fspecial('Gaussian',21,2);
blur=@(f,k)imfilter(f,k,'circular');
sigma=10;
og=blur(img,ker);
g=og+sigma*randn(size(img));
ForC='F'; %FFT-based preconditioner
mu=100;
delta=1;
frame=1;
Level=4;
theta=0.06;
wLevel=1;
%parameters for bilateral filtering
SigmaS=8;
SigmaR=40;
%=============================================

%%Another example.
%%==============================================
%%The following reproduce the results in Figure 4.1 (e) and (f). 
% img=double(imread('camera.png'));
% ker=fspecial('disk',3);
% blur=@(f,k)conv2(f,k,'same');
% sigma=5;
% og=blur(img,ker);
% g=og+sigma*randn(size(img));
% ForC='C'; %DCT-based preconditioner
% mu=100;
% delta=1;
% theta=0.02;
% frame=1;
% Level=4;
% wLevel=-1;
%%parameters for bilateral filtering
%SigmaS=4;
%SigmaR=16;
%==============================================

rec=LBregDebP(g,ker,blur,sigma,mu,delta,theta,ForC,frame,Level,wLevel);

brec=bilateralFilter(rec,rec,0, 255, SigmaS,SigmaR,SigmaS,SigmaR);
%brec=bilateralFilter(rec,rec,0, 255, 4,16,4,16); % for Camera Image
%brec=bilateralFilter(rec,rec,0, 255, 8,28,8,28); % for plate Image
%brec=bilateralFilter(rec,rec,0, 255, 32,8,32,8); % for Barbara Image
%brec=bilateralFilter(rec,rec,0, 255, 8,40,8,40); % for shape image.

figure,imshow(uint8(rec));
figure,imshow(uint8(brec));